(* 連続で分岐してるとこを展開できるかもね *)

open Global
open ILang

let cmp c x y = match c with Eq -> x = y | LE -> x <= y

let (<=>) x y = (* 静的に比較可能 *)
  match x,y with
  | Int _, Int _ | Float _, Float _ -> true
  | _ -> false

let h e =
  match e with
  | V _ | Op _ -> e
  | _ -> let name = Id.to_string (Id.new_id ".hogefunc") in
    let args = S.elements (fv e) in
    gl_funs := { name = name; args = args; body = e } :: !gl_funs;
    Op(Label name, List.map (fun x -> Var x) args)

let rec g e =
  match e with
  | Let(x,If(c,y,z,V i1,V i2),If(c2,Var x2,i3,e1,e2))
    when Id.equal x x2 && i1 <=> i2 && i1 <=> i3 ->
      let e3 = if cmp c2 i1 i3 then e1 else e2 in
      let e4 = if cmp c2 i2 i3 then e1 else e2 in
      If(c,y,z,Let(x,V i1,g e3),Let(x,V i2,g e4))
  | Let(x,If(c,y,z,V i1,V i2),If(c2,i3,Var x2,e1,e2))
    when Id.equal x x2 && i1 <=> i2 && i1 <=> i3 ->
      let e3 = if cmp c2 i3 i1 then e1 else e2 in
      let e4 = if cmp c2 i3 i2 then e1 else e2 in
      If(c,y,z,Let(x,V i1,g e3),Let(x,V i2,g e4))
  | Let(x,If(c,y,z,V i1,V i2),Let(w,If(c2,Var x2,i3,e1,e2),e3))
    when Id.equal x x2 && i1 <=> i2 && i1 <=> i3 ->
      let e4 = if cmp c2 i1 i3 then e1 else e2 in
      let e5 = if cmp c2 i2 i3 then e1 else e2 in
      g (Let(w,If(c,y,z,Let(x,V i1,e4),Let(x,V i2,e5)),e3))
  | Let(x,If(c,y,z,V i1,V i2),Let(w,If(c2,i3,Var x2,e1,e2),e3))
    when Id.equal x x2 && i1 <=> i2 && i1 <=> i3 ->
      let e4 = if cmp c2 i3 i1 then e1 else e2 in
      let e5 = if cmp c2 i3 i2 then e1 else e2 in
      g (Let(w,If(c,y,z,Let(x,V i1,e4),Let(x,V i2,e5)),e3))

  | Let(x,If(c,y,z,V i1,e1),If(c2,Var x2,i2,e2,e3))
    when Id.equal x x2 && i1 <=> i2 ->
      let e2,e3 = if cmp c2 i1 i2 then h (g e2), e3 else e2, h (g e3) in
      let e_ = if cmp c2 i1 i2 then e2 else e3 in
      If(c,y,z,
         Let(x, V i1, e_),
         g (Let(x, e1, If(c2,Var x,i2,e2,e3))))
  | Let(x,If(c,y,z,e1,V i1),If(c2,Var x2,i2,e2,e3))
    when Id.equal x x2 && i1 <=> i2 ->
      let e2,e3 = if cmp c2 i1 i2 then h (g e2), e3 else e2, h (g e3) in
      let e_ = if cmp c2 i1 i2 then e2 else e3 in
      If(c,y,z,
         g (Let(x, e1, If(c2,Var x,i2,e2,e3))),
         Let(x, V i1, e_))
  | Let(x,If(c,y,z,V i1,e1),If(c2,i2,Var x2,e2,e3))
    when Id.equal x x2 && i1 <=> i2 ->
      let e2,e3 = if cmp c2 i2 i1 then h (g e2), e3 else e2, h (g e3) in
      let e_ = if cmp c2 i2 i1 then e2 else e3 in
      If(c,y,z,
         Let(x, V i1, e_),
         g (Let(x, e1, If(c2,i2,Var x,e2,e3))))
  | Let(x,If(c,y,z,e1,V i1),If(c2,i2,Var x2,e2,e3))
    when Id.equal x x2 && i1 <=> i2 ->
      let e2,e3 = if cmp c2 i2 i1 then h (g e2), e3 else e2, h (g e3) in
      let e_ = if cmp c2 i2 i1 then e2 else e3 in
      If(c,y,z,
         g (Let(x, e1, If(c2,i2,Var x,e2,e3))),
         Let(x, V i1, e_))
  | Let(x,e1,e2) -> Let(x, g e1, g e2)
  | LetRec(x,ys,e1,e2) -> LetRec(x,ys, g e1, g e2)
  | If(c,x,y,e1,e2) -> If(c,x,y, g e1, g e2)
  | V _ | Op _ -> e

let f e =
  let funs = !gl_funs in
  gl_funs := [];
  List.iter
    (fun func -> let f_ = { func with body = Alpha.f (g func.body) } in
     gl_funs := f_ :: !gl_funs)
    funs;
  Alpha.f (g e)
