(* 不要定義除去その2 *)

open TreeAsm

let rec se exp =
  match exp with
  | Call _ | Rd | Op1(Wr,_) | St _ | Save _ -> true
  | If(_,_,_,e1,e2) | IfI(_,_,_,e1,e2) | FIf(_,_,_,e1,e2) -> se1 e1 || se1 e2
  | _ -> false
and se1 e =
  match e with
  | Ret exp -> se exp
  | Let(_,exp,e) -> se exp || se1 e

let rec g e =
  match e with
  | Ret exp -> Ret(g1 exp)
  | Let(_,Nop,e) -> g e
  | Let(x,exp,e) ->
      if is_reg x || se exp || S2.mem x (fv e) then Let(x, g1 exp, g e)
      else g e
and g1 exp =
  match exp with
  | If(c,x,y,e1,e2) -> If(c,x,y, g e1, g e2)
  | IfI(c,x,y,e1,e2) -> IfI(c,x,y, g e1, g e2)
  | FIf(c,x,y,e1,e2) -> FIf(c,x,y, g e1, g e2)
  | _ -> exp

let f xs = List.map (fun x -> { x with body = g x.body }) xs
