(* 񤭽Ф *)

open Printf
open Global
open LinearAsm

let rec g oc e =
  if e == end_node then ()
  else begin
    if e.label != nolabel then fprintf oc "%s:\n" e.label;
    fprintf oc "\t%s\n" (str e.exp);
    g oc e.cont;
  end

let rest = ref M2.empty

let rec iter ls e =
  if e == end_node then ls else
  let ls =
    try match e.exp with
    | JAL x | JUMP x | BE(_,_,x) | BNE(_,_,x) | BL(_,_,x) | BGE(_,_,x)
    | BEI(_,_,x) | BNEI(_,_,x) | BLI(_,_,x) | BGEI(_,_,x)
    | FBL(_,_,x) | FBGE(_,_,x) -> M2.find x !rest :: ls
    | _ -> ls
    with Not_found -> ls
  in
  iter ls e.cont

let rec write_fun oc x =
  if M2.mem x.fname !rest then begin
    rest := M2.remove x.fname !rest;
    let ls = iter [] x.entry in
    List.iter (write_fun oc) ls;
    fprintf oc "%s:\n" x.fname;
    g oc x.entry
  end

let f oc xs =
  Hashtbl.iter (fun k vs ->
    fprintf oc "%s:\n" k;
    ignore(
    Array.fold_left
      (fun i v -> fprintf oc "%s.%d:\n" k i;
        (match v with
         | ILang.Int i -> fprintf oc "\t.word %d\n" i
         | ILang.Float a -> fprintf oc "\t.word 0x%lx\n" (f2b a)
         | ILang.Label l -> fprintf oc "\t.word %s\n" l
         | _ -> fprintf oc "\t.word 0\n");
        i+1)
      0 vs))
    gl_vars;
  List.iter (fun x -> rest := M2.add x.fname x !rest) xs;
  let main = M2.find "main" !rest in
  write_fun oc main;
  List.iter (write_fun oc) xs
