(* 可能なら内部自由変数を外部自由変数にする *)

open Id
open ILang
open Global

let rec g e =
  match e with
  | Let(x, Op(Label ".tuple", ys), e2) ->
      let l = Id.to_string x in
      Hashtbl.add gl_tenv l x.typ;
      Hashtbl.add gl_vars l (Array.of_list ys);
      let rec iter i = function
        | [] -> g (Alpha.g (M.add x (Label l) M.empty) e2)
        | y::ys -> let e_ = iter (i+1) ys in
          if is_const y then e_ else
          Let(new_id_t "$" Type.Tunit,
              Op(Label ".t<-", [Label l; Int i; y]), e_)
      in
      iter 0 ys
  | Let(x, Op(Label ".create_array", [Int i; y]), e2) ->
      let l = Id.to_string x in
      Hashtbl.add gl_tenv l x.typ;
      Hashtbl.add gl_vars l (Array.make i y);
      let e_ = g (Alpha.g (M.add x (Label l) M.empty) e2) in
      if is_const y then e_
      else let rec iter i e =
        if i < 0 then e
        else iter (i-1)
            (Let(new_id_t "$" Type.Tunit,
                 Op(Label ".<-", [Label l; Int i; y]), e))
      in
      iter (i-1) e_
  | Let(x, e1, e2) -> Let(x, g e1, g e2)
  | LetRec(f,xs,e1,e2) -> LetRec(f, xs, e1, g e2)
  | V _ | Op _ | If _ -> e

let f e = g e
