(* 副作用のない関数を近似的に求める *)

open Builtin
open Global
open ILang

let result = ref S2.empty

let rec h env e =
  match e with
  | V _ -> false
  | Op(Label l, _) ->
      not (List.mem l Builtin.side_effective_funs) &&
      (List.mem l Builtin.fun_names ||
       S2.mem l !result)
  | Op(Var x, _) -> S.mem x env
  | Op _ -> assert false
  | If(_,_,_,e1,e2) | Let(_,e1,e2) -> h env e1 && h env e2
  | LetRec(x,_,e1,e2) ->
      let env_ = S.add x env in
      h (if h env_ e1 then env_ else env) e2

let rec g () =
  if List.fold_left
      (fun modified { name = x; body = e } ->
        if not (S2.mem x !result) && h S.empty e
        then (result := S2.add x !result; true)
        else modified)
      false !gl_funs
  then g ()

let f e =
  result := S2.empty;
  g ();
  e
