(* んー何というか *)
open Global
open ILang

let threshold = ref 3

let h e =
  match e with
  | V _ | Op _ -> e
  | _ -> let name = Id.to_string (Id.new_id ".hogefunc") in
    let args = S.elements (fv e) in
    gl_funs := { name = name; args = args; body = e } :: !gl_funs;
    Op(Label name, List.map (fun x -> Var x) args)

let rec g count e =
  if count > !threshold then e else
  match e with
  | If(c,x,y,e1,e2) -> If(c,x,y, h e1, h e2)
  | Let(x,e1,e2) -> Let(x,e1, g (count + size e1) e2)
  | LetRec(x,ys,e1,e2) -> assert false
  | _ -> e

let f e =
  let funs = !gl_funs in
  gl_funs := [];
  List.iter
    (fun x ->
      let x_ = { x with body = g 0 x.body } in
      gl_funs := x_ :: !gl_funs)
    funs;
  e
